<?php
namespace Ak\Task\Form;

use Ak\Orm\Form\EntityForm;
use Ak\Task\Task;
use Laminas\Form\ElementInterface;
use Laminas\Form\Form;
use Traversable;

/**
 * Class TaskForm
 *
 * @package Ak\Task\Form
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/task
 */
class TaskForm extends EntityForm
{
    /**
     * Ako zadatak nema postavke, preskačemo element.
     *
     * @param array|Traversable|ElementInterface $elementOrFieldset
     * @param array $flags
     *
     * @return $this|Form
     */
    public function add($elementOrFieldset, array $flags = [])
    {
        if (
            ($elementOrFieldset instanceof ElementInterface && $elementOrFieldset->getName() === 'params') ||
            (is_array($elementOrFieldset) && ($elementOrFieldset['attributes']['name'] ?? '') === 'params')
        ) {
            /** @var Task $entity */
            $entity = $this->allowedObjectBindingClass;
            $entity = new $entity();

            if (!$entity->getParams()) {
                return $this;
            }
        }

        return parent::add($elementOrFieldset, $flags);
    }
}
