<?php
namespace Ak\Task\Handler;

use Ak\Task\Task;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Laminas\Diactoros\Response\HtmlResponse;

/**
 * Class Index
 *
 * @package Ak\Task\Handler
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/task
 */
final class Index extends AbstractHandler
{
    /**
     * Handles a request and produces a response.
     *
     * May call other collaborating code to generate the response.
     *
     * @param ServerRequestInterface $request
     * @return ResponseInterface
     */
    public function handle(ServerRequestInterface $request): ResponseInterface
    {
        $query = $this->em->createQueryBuilder()
            ->select('t')
            ->from(Task::class, 't')
            ->orderBy('t.name')
            ->getQuery();

        return new HtmlResponse(
            $this->render('task-manager/index', [
                'tasks' => $query->getResult(),
            ])
        );
    }
}
