<?php
namespace Ak\Task;

use Gedmo\Timestampable\Timestampable;

/**
 * Zadatak.
 *
 * @package Ak\Task
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/task
 */
interface TaskInterface extends Timestampable
{
    const STATUS_STOPPED = 'stopped';

    /**
     * Vraća ime zadatka.
     *
     * @return string
     */
    public function getName(): string;

    /**
     * Vraća postavke zadatka ako postoje.
     *
     * @return object|null
     */
    public function getParams(): ?object;

    /**
     * Pokreće ovaj zadatak.
     */
    public function run(): void;
}