<?php
namespace AkTest\Task;

use Ak\Task\Task;

/**
 * Class TaskTest
 *
 * @package AkTest\Task
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/task
 */
final class TaskTest extends AbstractTestCase
{
    /**
     * @throws \Doctrine\DBAL\DBALException
     */
    public function testTaskHasCreatedAtTimestamp()
    {
        $task = new Task();
        $task->setName('test');
        $this->persistEntity($task);

        $conn = $this->getConnection();
        $row = (array) $conn->query('SELECT * FROM task WHERE id = 1')->fetch();

        $now = date('Y-m-d H:i:s');
        $this->assertEquals($now, $row['createdAt']);
        $this->assertEquals($now, $row['updatedAt']);
    }

    /**
     * @throws \Doctrine\DBAL\DBALException
     */
    public function testTaskHasUpdatedAtTimestamp()
    {
        $past = '2014-04-15 12:45:44';
        $now = date('Y-m-d H:i:s');

        $conn = $this->getConnection();
        $conn->insert('task', [
            'id' => 1,
            'type' => 'task',
            'createdAt' => $past,
            'updatedAt' => $past,
            'name' => 'test',
        ]);

        /** @var Task $task */
        $task = $this->findEntity(Task::class, 1);

        $task->setName('new name');
        $this->persistEntity($task);

        $updatedAt = $conn->query('SELECT updatedAt FROM task WHERE id = 1')->fetch()['updatedAt'];
        $this->assertEquals($now, $updatedAt);
    }
}